'Declare  SHOW_SYSTEM_VARIABLES = OFF    '    Proteus    
Declare  FSR_CONTEXT_SAVE = OFF         '       FSR
Declare  Reminders = OFF                '    
'Declare  Warnings = OFF                 '    
Declare  Optimiser_Level 0             '    
Declare  Bootloader = OFF               '   
Declare Float_Display_Type = LARGE                                                                  
'--------------------------  ------------------------------------                                                                   
Device = 16F877A                        '  
Xtal = 20                               '    20  

Config CP_OFF, DEBUG_OFF, WRT_OFF, CPD_OFF, LVP_OFF, PWRTE_OFF, WDTE_OFF, HS_OSC, BOREN_OFF, CP_OFF, WDT_OFF
                                                                  
'--------------------------   ------------------------------------
                                                                   
Declare  Adin_Res 10                    '    
Declare  Adin_Tad FRC                   '   
Declare  Adin_Stime  50                 '                                                                          
'--------------------------    ------------------------
                                                                   
Declare  LCD_Type ALPHA                 '   -  -
Declare  LCD_DTPin  PORTB.4             '   
Declare  LCD_ENPin  PORTB.3             '   E
Declare  LCD_RSPin  PORTB.2             '   RS
Declare  LCD_Interface  4               '   
Declare  LCD_CommandUs  2000            '    
Declare  LCD_DataUs  50                 '    
Declare  LCD_Lines   2                  '                                                                      
'--------------------------   ---------------------------------                                                                  
'PortB_Pullups = OFF                     '     PORTB
Declare  All_Digital = OFF              '       
'ADCON1 = %10000000 	  	            '    PORTA   
TRISA = %00001111 	  	                '   () AN0,AN1 (PORTA.0 ,PORTA.1) 
TRISB = %00000000
PORTB = %00000000
TRISC = %00000000 
PORTC = %00000000
TRISD = %11110000 
PORTD = %00000000                                                                   

                                                                 
'-------------------------- OPTION_REG ----------------------------------------
                                                                   
Symbol PS0 = OPTION_REG.0               '    TMR0
Symbol PS1 = OPTION_REG.1               '    TMR0
Symbol PS2 = OPTION_REG.2               '    TMR0
Symbol PSA = OPTION_REG.3               '   
Symbol T0SE = OPTION_REG.4              '    TMR0    
Symbol T0CS = OPTION_REG.5              '     TMR0 
Symbol INTEDG = OPTION_REG.6            '         INT
Symbol NOT_RBPU = OPTION_REG.7          '     PORTB
                                                                   
'-------------------------- INTCON --------------------------------------------
                                                                   
Symbol RBIF = INTCON.0                  '     PORTB.4-PORTB.7
Symbol INTF = INTCON.1                  '     PORTB.0(INT)
Symbol T0IF = INTCON.2                  '   TMR0
Symbol RBIE = INTCON.3                  '     PORTB.4-PORTB.7
Symbol INTE = INTCON.4                  '     PORTB.0(INT) 
Symbol T0IE = INTCON.5                  '      TMR0
Symbol PEIE = INTCON.6                  '      
Symbol GIE = INTCON.7                   '    
                                                                   
'-------------------------- ADCON0 -------------------------------------------------
                                                                   
'Symbol ADON = ADCON0.0                  '   
'Symbol NOT_DONE = ADCON0.2              '   
'Symbol GO_DONE = ADCON0.2               '   
'Symbol CHS0 = ADCON0.3                  '   
'Symbol CHS1 = ADCON0.4                  '   
'Symbol CHS2 = ADCON0.5                  '   
'Symbol ADCS0 = ADCON0.6                 '    
'Symbol ADCS1 = ADCON0.7                 '    
                                                                   
'-------------------------- ADCON1 -------------------------------------------------
                                                                   
'Symbol PCFG0 = ADCON1.0                 '   
'Symbol PCFG1 = ADCON1.1                 '   
'Symbol PCFG2 = ADCON1.2                 '   
'Symbol PCFG3 = ADCON1.3                 '   
'Symbol ADFM = ADCON1.7                  '   
                                                                   
'--------------------------   ---------------------------
                                                                   
Dim   BATMIN           As  Float         '   
Dim   BATNOM           As  Float         '
Dim   BATMAX           As  Float         '
Dim   SELBAT           As  Byte          '   
Dim   BATTYPE          As  Byte          '
Dim   REGIM            As  Byte          '
Dim   CHARGECURENT     As  Float         '
Dim   CHARGECURENTMAX  As  Float         '
Dim   DISCHARCURENT    As  Float         '
Dim   DISCHARCURENTMAX As  Float         '
Dim   C                As  Bit           '      
Dim   BatCap           As  Float         '
Dim   BatCapMAX        As  Float         '
Dim   CELLBAT          As  Byte          '   
Dim   CELLBATMAX       As  Byte          '

Dim   VAR1             As  Word          '   
Dim   TempVAR1         As  Word          '
Dim   UBATTERY         As  Float         '
 
Dim   VAR2             As  Word          '
Dim   TempVAR2         As  Word
Dim   TOKCHARGE        As  Float         '
Dim   TOKCHARGE1       As  Word          '
Dim   TOKBATCHARGE     As  Float         '   

Dim   VAR3             As  Word          '
Dim   TempVAR3         As  Word          '
Dim   TOKDISCHARGE     As  Float         '
Dim   TOKDISCHARGE1    As  Word          '
Dim   TOKBATDISCHARGE  As  Float         '   

Dim   TOKCHARGEEND     As  Float         '
Dim   TimeCHARGE       As  Byte          '
Dim   PWMOUT1          As  Word          '  1 
Dim   PWMOUT2          As  Word          '  2 
Dim   BIG              As  Dword         '    
Dim   BIG1             As  BIG.HighWord  '                                        
Dim   Sec              As  Byte          '
Dim   Minute           As  Byte         '
Dim   Hour             As  Byte          '                   
Dim   TIME             As  Float         '
Dim   CAPACITYACCU2    As  Float         '
Dim   CAPACITYACCU3    As  Float         '
Dim   Minute1          As  Float         '
Dim   TEMPTOKCHARGE    As  Float         ' 
Dim   SUMATOKCHARGE    As  Float         '
Dim   SUMATOKCHARGE1   As  Float         '
Dim   ccc              As  Byte
Dim   Tokr             As  Byte          '
Dim   TEMPOKR          As  Float         '

'--------------------------   -----------------------------                                                                   
Symbol   OK =        PORTD.7            '  
Symbol   UP =        PORTD.6            '  
Symbol   DOWN =      PORTD.5            '   
Symbol   MENU =      PORTD.4            '  
Symbol   PIEZO =     PORTC.5            ' 
Symbol   CHARGEDIS = PORTD.3            '   - 
Symbol   COMPLETE =  PORTD.2            ' 
Symbol   FAN =       PORTD.1            ' 
Symbol   BACKLIGHT = PORTB.1            '                                                     

''-------------------------- ADCON0, ADCON1 -----------------------------------
'                                        '   -  . Vref + = Vdd. Vref - = Vss
ADCON0 = %1100000                       '   ADCON0
ADCON1 = %10000000                      '   ADCON1
                                                                   
'--------------------------  TMR0   --------------------
OPTION_REG = %10000111
TMR0 = $00                              '   TMR0

T0IE = 0                                                                    
GIE = 0                                 '   
BIG = 5000000
                                                                   
'On_Interrupt GoTo  Int_Label

 
BACKLIGHT = 1
REGIM = 1                                  
BatCap = 0.0
SELBAT = 1
CELLBAT = 0
CHARGECURENT = 0
DISCHARCURENT = 0
TimeCHARGE = 0
Tokr = 0
TIME = 0
CAPACITYACCU2 = 0
CAPACITYACCU3 = 0
SUMATOKCHARGE = 0
SUMATOKCHARGE1 = 0
TEMPOKR = 0

'-------------------------- --------------------------

Print At 1, 1, "BATTERY CHARGER "
Print At 2, 1, "      2016      "
DelayMS 2000     
Print At 1, 1, " V1.4    070216  "
Print At 2, 1, "    Andriy S     "
DelayMS 2000                                                                   
Cls                                
                                                                   
'--------------------------   -------------------------

MainMENU:

    BACKLIGHT = 1
    CHARGEDIS = 0
    PWMOUT1 = 0
    PWMOUT2 = 0
    
    While 1 = 1
    
        GoSub READADC
        
        If UP = 0 Then
               DelayMS 200
               GoSub BEEP  
               Inc PWMOUT1
               If  PWMOUT1 < 0 Then PWMOUT1 = 0
        EndIf
        
        If DOWN = 0 Then 
                DelayMS 200
                GoSub BEEP 
                Dec PWMOUT1
                If PWMOUT1 > 254 Then PWMOUT1 = 254
        EndIf          
        
        If OK = 0 Then
               DelayMS 200
               GoSub BEEP  
               Inc PWMOUT2 
               If  PWMOUT2 < 0 Then PWMOUT2 = 0
        EndIf
        
        If MENU = 0 Then 
                DelayMS 200
                GoSub BEEP 
                Dec PWMOUT2
                If PWMOUT2 > 254 Then PWMOUT2 = 254
        EndIf 
           
        HPWM 1, PWMOUT1 , 16000
        HPWM 2, PWMOUT2 , 16000
        
        Print At 1,1, Dec3 UBATTERY , "V"
        Print At 1,8, Dec3 PWMOUT1  
        Print At 1,12, Dec3 TOKCHARGE , "A " 
        
'        Print At 2,1, Dec3 UBATTERY , "V " 
        Print At 2,8, Dec3 PWMOUT2
        Print At 2,12, Dec3 TOKDISCHARGE , "A "           
    Wend
    
GoTo  MainMENU                              '     
 
'''--------------------------  --------------------------
''Int_Label:                                          ' 
''Context Save                                        '    

''If T0IF = 1 Then Dec BIG1	                        '   TMR0,        BIG1, 
''                                                    '   ,    65536  BIG,    

''If BIG < 0 Then BIG = BIG + 5000000 : Inc Sec       '  BIG < 0    ,     
''                                                    '  5000000 
''T0IF = 0                                            '    

''Context Restore                                                                   
'''--------------------------CAPACITY--------------------------

''BATTERYCAP:
             
''    If UP = 0 Then 
''              DelayMS 200
''              GoSub BEEP  
''              BatCap = BatCap  + 0.1
''    EndIf          
    
''    If BatCap >= BatCapMAX Then BatCap = BatCapMAX
    
''    If DOWN = 0 Then 
''                DelayMS 200
''                GoSub BEEP  
''                BatCap = BatCap - 0.1
''    EndIf             
    
''    If BatCap <= 0 Then BatCap = 0
    
''    Print At 1, 1 ,  "CAPACITY"
''    Print At 1, 10,  Dec1 BatCap , "Ah"
    
''    If BatCap > 0 And OK = 0 Then 
''                DelayMS 200
''                GoSub BEEP  
''                GoTo CEllBATTERY
''    EndIf                                  
    
''    If MENU = 0 Then 
''                DelayMS 200
''                GoSub BEEP
''                GoSub OSTANOV  
''                GoTo MainMENU
''    EndIf
''GoTo BATTERYCAP

'''-------------------------- CELL--------------------------

''CEllBATTERY:
         
''    If UP = 0 Then 
''            DelayMS 200
''            GoSub BEEP  
''            Inc CELLBAT
''            If CELLBAT >= CELLBATMAX Then CELLBAT = CELLBATMAX
''    EndIf          
    
    
''    If DOWN = 0 Then 
''            DelayMS 200
''            GoSub BEEP 
''            Dec CELLBAT
''            If CELLBAT <= 0 Then CELLBAT = 0
''    EndIf             
    
''    Print At 2, 1 ,  "CELL   "
''    Print At 2, 10,  Dec1 CELLBAT
    
''    If CELLBAT > 0 And OK = 0 Then
''                DelayMS 200
''                GoSub BEEP
''                Cls
''                GoTo REGIMBAT
''    EndIf
''    If MENU = 0 Then 
''                DelayMS 200
''                GoSub BEEP
''                GoSub OSTANOV
''                GoTo MainMENU
''    EndIf                                      
''GoTo CEllBATTERY


'''----------------------- --------------------------
                                                                   
''REGIMBAT:

''    If BATTYPE = 1 Then  Print At 1, 1, "NiMH   " 
''    If BATTYPE = 2 Then  Print At 1, 1, "SLA 12 " 
''    If BATTYPE = 3 Then  Print At 1, 1, "LiIon  "  
''    If BATTYPE = 4 Then  Print At 1, 1, "LiPol  " 
    
''    If UP = 0 Then 
''             DelayMS 100
''             GoSub BEEP  
''             Inc REGIM
''             If REGIM > 3 Then REGIM = 1
''    EndIf
        
    
''    If DOWN = 0 Then 
''                DelayMS 100
''                GoSub BEEP  
''                Dec REGIM
''                If REGIM < 0 Then REGIM = 3
''    EndIf
    
''    DelayMS 200
''    Select REGIM
''        Case 1                                          ' If REGIM = 1 Then 
''            Print At 1, 8, "CHARGE   "
                     
''                     If OK = 0 Then 
''                     DelayMS 200
''                     GoSub BEEP
''    '                 Cls
''                     GoTo CHARGECUR                 
''    EndIf   
                       
''        Case 2                                          ' If REGIM = 2 Then 
''            Print At 1, 8, "DISCHARGE"
                     
''                     If OK = 0 Then 
''                     DelayMS 200
''                     GoSub BEEP
''    '                 Cls
''                     GoTo DISCHARGECUR                 
''    EndIf
        
''        Case 3                                          ' If REGIM = 3 Then 
''            Print At 1, 8, "CYCL D/C " 
                      
''                      If OK = 0 Then 
''                      DelayMS 200
''                      GoSub BEEP
''    '                  Cls
''                      GoTo CYKL                 
''    EndIf
    
''    EndSelect
    
''    If MENU = 0 Then 
''                DelayMS 200
''                GoSub BEEP
''                GoSub OSTANOV          
''                GoTo MainMENU
''    EndIf                
''GoTo REGIMBAT 

'''----------------------- --------------------------
''CHARGECUR:
 
''    Print At 2, 1, "CURENT"
''    Print At 2, 10, Dec1 CHARGECURENT , "C"
''    If UP = 0 Then 
''              DelayMS 200
''              GoSub BEEP  
''              CHARGECURENT = CHARGECURENT + 0.1
''              If CHARGECURENT > CHARGECURENTMAX Then CHARGECURENT = CHARGECURENTMAX
''    EndIf          
    
''    If DOWN = 0 Then 
''                DelayMS 200
''                GoSub BEEP 
''                CHARGECURENT = CHARGECURENT - 0.1
''                If CHARGECURENT < 0 Then CHARGECURENT = 0
''    EndIf             
    
''    If CHARGECURENT > 0 And OK = 0 Then
''                                   DelayMS 200
''                                   GoSub BEEP
''                                   Sec = 0
''                                   Cls
''                                   GoTo CHARGE
''    EndIf
    
''    If MENU = 0 Then 
''                DelayMS 200
''                GoSub BEEP
''                GoSub OSTANOV  
''                GoTo MainMENU
''    EndIf             
''GoTo CHARGECUR

'''----------------------- --------------------------

''DISCHARGECUR:

''    Print At 2, 1, "CURENT"
''    Print At 2, 10, Dec1 DISCHARCURENT , "C"
    
''    If UP = 0 Then 
''            DelayMS 200
''            GoSub BEEP  
''            DISCHARCURENT = DISCHARCURENT + 0.1
''            If DISCHARCURENT > DISCHARCURENTMAX Then DISCHARCURENT = DISCHARCURENTMAX
''    EndIf          
    
    
''    If DOWN = 0 Then 
''            DelayMS 200
''            GoSub BEEP 
''            DISCHARCURENT = DISCHARCURENT - 0.1
''            If DISCHARCURENT < 0 Then DISCHARCURENT = 0
''    EndIf             
    
    
''    If DISCHARCURENT > 0 And OK = 0 Then
''                                    DelayMS 200
''                                    GoSub BEEP
''                                    Sec = 0
''                                    Cls                               
''                                    GoTo DISCHARGE
''    EndIf
    
''    If MENU = 0 Then 
''                DelayMS 200
''                GoSub BEEP
''                GoSub OSTANOV           
''                GoTo MainMENU
''    EndIf            
''GoTo DISCHARGECUR

'''-------------------------- --------------------------
''CYKL:

''    If BATTYPE = 1 Then  Print At 1, 1, "NiMH  DIS/CHARGE" 
''    If BATTYPE = 2 Then  Print At 1, 1, "SLA   DIS/CHARGE" 
''    If BATTYPE = 3 Then  Print At 1, 1, "LiIon DIS/CHARGE" 
''    If BATTYPE = 4 Then  Print At 1, 1, "LiPol DIS/CHARGE" 
     
''    If UP = 0 Then 
''            DelayMS 200
''            GoSub BEEP  
''            DISCHARCURENT = DISCHARCURENT + 0.1
''            If DISCHARCURENT > DISCHARCURENTMAX Then DISCHARCURENT = DISCHARCURENTMAX
''            CHARGECURENT = DISCHARCURENT
''    EndIf          
    
    
''    If DOWN = 0 Then 
''            DelayMS 200
''            GoSub BEEP 
''            DISCHARCURENT = DISCHARCURENT - 0.1
''            If DISCHARCURENT < 0 Then DISCHARCURENT = 0
''             CHARGECURENT = DISCHARCURENT
''    EndIf
    
    
''    Print At 2, 1 , "DC", Dec1 CHARGECURENT , "C"
''    Print At 2, 10, "CC", Dec1 DISCHARCURENT ,"C"
''    DelayMS 200
    
''    If DISCHARCURENT > 0  And OK = 0  Then DelayMS 200 : Cls : GoTo DISCHARGE
    
''    If MENU = 0 Then 
''                DelayMS 200
''                GoSub BEEP
''                GoSub OSTANOV            
''                GoTo MainMENU
''    EndIf 
''GoTo CYKL


'''-------------------------- --------------------------
''CHARGE:

''    CHARGEDIS = 1
''    TOKBATCHARGE =  BatCap * CHARGECURENT  '  
''    TOKCHARGEEND = BatCap / 20 '    
''    PWMOUT2 = 0 
     
''    T0IE = 1                                                                    
''    GIE = 1                                 '   
''    BIG = 5000000
                                                                       
''    On_Interrupt GoTo  Int_Label
            
''    While 1 = 1
'''        VAR1 = ADIn 0              '    0-       VAR1
'''        UBATTERY = VAR1 / 40     '   20
        
'''        VAR2 = ADIn 1 	           '    1-       VAR2  
'''        TOKCHARGE = VAR2 / 200
''        GoSub READADC
                
'''        TEMPICHAR = TEMPICHAR + TOKCHARGE  '  
        
'''        TEMPuCHR = TEMPuCHR + UBATTERY     '  
        
''        Inc Tokr
        
'''        If Tokr = 10 Then 
'''                    Tokr = 0
''''                    TEMPICHAR = TEMPICHAR / 10
''''                    TEMPuCHR  = TEMPuCHR / 10             
'''                    Print At 2, 11, Dec3 TEMPICHAR ,"A " 
'''                    Print At 2, 2,  Dec3 UBATTERY , "V  "        '
'''        EndIf 
                                           
''        If Tokr = 15 Then
        
''            Tokr = 0

''            Print At 2, 2,  Dec2 UBATTERY , "V "

''            If TOKCHARGE <= 1.000 Then
''                TOKCHARGE1 = TOKCHARGE * 1000
''                Print At 2, 10, "I=", Dec3 TOKCHARGE1 ,"mA "
''            Else
''                Print At 2, 10, "I=", Dec2 TOKCHARGE ,"A "
''            EndIf

''        EndIf
        
''        If TOKCHARGE >= 4.5 Then Cls : GoSub BEEP : GoSub OSTANOV: GoTo SHORTCIRCUT '  
                 
''        If TOKCHARGE > 1.1 Then FAN = 1   '   1             
''        If TOKCHARGE < 0.9 Then FAN = 0   '   1  
         
''        Select BATTYPE
        
''        Case 1                                                  
'''        If BATTYPE = 1 Then               
''               Print At 1, 1, "NiMH"   'BATTYPE = 1   NiMH             
''               If UBATTERY > BATMAX * CELLBAT Then Cls : GoSub BEEP : GoSub OSTANOV : GoTo NOBATTERY
''               If TOKCHARGE < TOKBATCHARGE Then Inc PWMOUT1   '     
''               If TOKCHARGE > TOKBATCHARGE Then Dec PWMOUT1   '               
''               If CHARGECURENT = 0.1 Then TimeCHARGE = 14     '   14 
''               If CHARGECURENT = 0.2 Then TimeCHARGE = 7      '   7 
''               If CHARGECURENT = 0.3 Then TimeCHARGE = 5      '   5 
''               If MENU = 0 Or Hour = TimeCHARGE Then Cls : GoSub BEEP : GoTo CHARGEEND '                   
'''        EndIf
        
''        Case 2                       
'''        If BATTYPE = 2 Then               
''               Print At 1, 1, "SLA "   'BATTYPE = 2   SLA
''               If MENU = 0 Then Cls : GoSub BEEP : GoTo CHARGEEND '   
''               If UBATTERY > BATMAX * CELLBAT Then Cls : GoSub BEEP : GoSub OSTANOV : GoTo NOBATTERY '
''               If UBATTERY < BATNOM * CELLBAT Then Inc PWMOUT1    '      
''               If UBATTERY > BATNOM * CELLBAT Then Dec PWMOUT1    '                                                          
''               If TOKCHARGE > TOKBATCHARGE Then PWMOUT1 = PWMOUT1 - 2 '      
''               If Minute > 10 And TOKCHARGE < TOKCHARGEEND Then Cls : GoSub BEEP: GoTo CHARGEEND '  
'''        EndIf
                                   
''        Case 3                      
'''        If BATTYPE = 3 Then               
''               Print At 1, 1, "LiIo"   'BATTYPE = 3   LiIon 
''               If MENU = 0 Then Cls : GoSub BEEP : GoTo CHARGEEND  '              
''               If UBATTERY > BATMAX * CELLBAT Then Cls :GoSub BEEP : GoSub OSTANOV:GoTo NOBATTERY '              
''               If UBATTERY < BATNOM * CELLBAT Then Inc PWMOUT1      '     
''               If UBATTERY > BATNOM * CELLBAT Then Dec PWMOUT1      '                             
''               If TOKCHARGE > TOKBATCHARGE Then PWMOUT1 = PWMOUT1 - 2 '                 
''               If Minute > 10 And TOKCHARGE < TOKCHARGEEND Then  Cls : GoSub BEEP : GoTo CHARGEEND  '  
'''        EndIf
                                   
''        Case 4
                                                      
'''        If BATTYPE = 4 Then                              
''               Print At 1, 1, "LiPo"   'BATTYPE = 4   LiPol
''               If MENU = 0 Then Cls : GoSub BEEP : GoTo CHARGEEND  '  
''               If UBATTERY > BATMAX * CELLBAT Then Cls :GoSub BEEP :GoSub OSTANOV: GoTo NOBATTERY'
''               If UBATTERY < BATNOM * CELLBAT Then Inc PWMOUT1      '      
''               If UBATTERY > BATNOM * CELLBAT Then Dec PWMOUT1      '       
''               If TOKCHARGE > TOKBATCHARGE Then PWMOUT1 = PWMOUT1 - 2 '      
''               If Minute > 10 And TOKCHARGE < TOKCHARGEEND Then Cls : GoSub BEEP : GoTo CHARGEEND '                                 
'''        EndIf
        
''        EndSelect
                        
''        If PWMOUT1 < 0   Then PWMOUT1 = 0                                        
''        If PWMOUT1 > 254 Then PWMOUT1 = 254
        
''        HPWM 1, PWMOUT1 , 16000
''        HPWM 2, PWMOUT2 , 16000
         
''        If Sec > 59 Then Sec = 0 : Inc Minute : BACKLIGHT = 0 '  60  ,     ,   
''        If Minute > 59 Then Minute = 0 : Inc Hour             '  60  ,    0 ,  
        
''        If Sec > 0  Then                                       '   
''                    SUMATOKCHARGE = SUMATOKCHARGE + TOKCHARGE  '
''                    Inc TEMPOKR                                '
''        EndIf
        
''        SUMATOKCHARGE1  = SUMATOKCHARGE  / TEMPOKR  '      
        
''        Minute1 = Minute / 60                       '     0,1 
''        TIME = Hour + Minute1                       '     
        
''        CAPACITYACCU2 = TIME * SUMATOKCHARGE1       '
''        CAPACITYACCU3 = CAPACITYACCU2 / 1.4         '      1,4 ,     1,4    
         
''        Print At 1, 7, "CHR"                        '   
''        Print At 1, 12, Dec2 Hour, ":", Dec2 Minute '   
                 
''        If UP = 0 Or DOWN = 0 Then BACKLIGHT = 1    '  
        
''    Wend
                          
''GoTo CHARGE

'''----------------------------------------------------
''DISCHARGE:

''    CHARGEDIS = 1
''    TOKBATDISCHARGE = BatCap * DISCHARCURENT '  
''    PWMOUT1 = 0
    
''    T0IE = 1                                                                    
''    GIE = 1                                 '   
''    BIG = 5000000
                                                                       
''    On_Interrupt GoTo  Int_Label 
      
''    While 1 = 1
    
''        GoSub READADC
'''        VAR1 = ADIn 0              '    0-       VAR1
'''        TempVAR1 = (TempVAR1 + VAR1 * 15) / 16
'''        UBATTERY = TempVAR1 / 40       '   20
         
'''        VAR3 = ADIn 2
'''        TOKBATDIS = VAR3 /  200

''        If TOKDISCHARGE < TOKBATDISCHARGE Then Inc PWMOUT2   '     
''        If TOKDISCHARGE = TOKBATDISCHARGE Then Nop
''        If TOKDISCHARGE > TOKBATDISCHARGE Then Dec PWMOUT2   '       
                       
''        Inc Tokr
        
'''        TEMPuCHR = TEMPuCHR + UBATTERY      '  
'''        TEMPICHAR = TEMPICHAR + TOKBATDIS   '  
'''        If Tokr = 10 Then 
'''                    Tokr = 0
'''                    TEMPICHAR = TEMPICHAR /10
'''                    TEMPuCHR  = TEMPuCHR / 10            
'''                    Print At 2, 11, Dec3 TEMPICHAR ,"A "
'''                    Print At 2, 2,  Dec3 TEMPuCHR  , "V  " 
'''        EndIf

''        If Tokr = 15 Then
        
''            Tokr = 0

''            Print At 2, 2,  Dec2 UBATTERY , "V "

''            If TOKDISCHARGE <= 1.000 Then
''                TOKDISCHARGE1 = TOKDISCHARGE * 1000
''                Print At 2, 11, "I=", Dec3 TOKDISCHARGE1 ,"mA "
''            Else
''                Print At 2, 11, "I=", Dec2 TOKDISCHARGE ,"A "
''            EndIf

''        EndIf                
''        If TOKDISCHARGE > 1.1 Then FAN = 1  '   1   
''        If TOKDISCHARGE < 0.9 Then FAN = 0  '   1  
        
''        If TOKDISCHARGE >= 4.5 Then Cls :GoSub BEEP : GoSub OSTANOV: GoTo SHORTCIRCUT '  
                               
''        If BATTYPE = 1 Then 
''                       Print At 1, 1, "NiMH "    'BATTYPE = 1  NiMH              
'''                       If TOKBATDIS < TOKBATDISCHARGE Then Inc PWMOUT2   '     
'''                       If TOKBATDIS > TOKBATDISCHARGE Then Dec PWMOUT2   '      
''                       If UBATTERY < BATMIN * CELLBAT Then Cls :GoSub BEEP :GoSub OSTANOV: GoTo NOBATTERY '  
''                       If UBATTERY < 1* CELLBAT And REGIM = 3 Then GoSub CLEARDISCHARGE : GoTo CHARGE     '     
''                       If UBATTERY < 1* CELLBAT  Or MENU = 0 Then Cls :GoSub BEEP : GoTo DISCHARGEEND     '  
                                    
''        EndIf               
''        If BATTYPE = 2 Then 
''                       Print At 1, 1, "SLA  "    'BATTYPE = 2   SLA          
'''                       If TOKBATDIS < TOKBATDISCHARGE Then Inc PWMOUT2   '     
'''                       If TOKBATDIS > TOKBATDISCHARGE Then Dec PWMOUT2   '      
''                       If UBATTERY < BATMIN * CELLBAT Then Cls :GoSub BEEP :GoSub OSTANOV: GoTo NOBATTERY '               
''                       If UBATTERY < 10 And REGIM = 3 Then GoSub CLEARDISCHARGE : GoTo CHARGE            '     
''                       If UBATTERY < 10  Or MENU = 0 Then Cls :GoSub BEEP : GoTo DISCHARGEEND            '  
                                     
''        EndIf               
''        If BATTYPE = 3 Then 
''                       Print At 1, 1, "LiIo "    'BATTYPE = 3  LiIon 
'''                       If TOKBATDIS < TOKBATDISCHARGE Then Inc PWMOUT2  '     
'''                       If TOKBATDIS > TOKBATDISCHARGE Then Dec PWMOUT2  '      
''                       If UBATTERY < BATMIN * CELLBAT Then Cls :GoSub BEEP :GoSub OSTANOV: GoTo NOBATTERY '                
''                       If UBATTERY < 3 * CELLBAT And REGIM = 3 Then GoSub CLEARDISCHARGE : GoTo CHARGE  '     
''                       If UBATTERY < 3 * CELLBAT Or MENU = 0 Then Cls :GoSub BEEP : GoTo DISCHARGEEND   '  
                                                   
''        EndIf               
''        If BATTYPE = 4 Then 
''                       Print At 1, 1, "LiPo "    'BATTYPE = 4    LiPol 
'''                       If TOKBATDIS < TOKBATDISCHARGE Then Inc PWMOUT2   '     
'''                       If TOKBATDIS > TOKBATDISCHARGE Then Dec PWMOUT2   '      
''                       If UBATTERY < BATMIN * CELLBAT Then Cls :GoSub BEEP :GoSub OSTANOV: GoTo NOBATTERY '                
''                       If UBATTERY < 3 * CELLBAT And REGIM = 3 Then GoSub CLEARDISCHARGE :  GoTo CHARGE   '     
''                       If UBATTERY < 3* CELLBAT  Or MENU = 0 Then Cls :GoSub BEEP : GoTo DISCHARGEEND     '  
                       
''        EndIf
                                     
''        If PWMOUT2 < 0   Then PWMOUT2 = 0 
''        If PWMOUT2 > 254 Then PWMOUT2 = 254
        
''        HPWM 1, PWMOUT1 , 16000 '
''        HPWM 2, PWMOUT2 , 16000 '
         
        
''        If Sec > 59 Then Sec = 0 : Inc Minute : BACKLIGHT = 0   '  60  ,     ,   
''        If Minute = 59 Then Minute = 0 : Inc Hour               '  60  ,    0 ,   
        
''        Print At 1, 7, "DIS"
''        Print At 1, 12, Dec2 Hour, ":", Dec2 Minute           '  
        
        
''        Minute1 = Minute / 60                                 '   0,1 
''        TIME = Hour + Minute1                                 '   
        
''        If Sec > 0  Then                                      '   
''                    SUMATOKCHARGE = SUMATOKCHARGE + TOKBATDISCHARGE ' 
''                    Inc TEMPOKR                               '
''        EndIf
        
''        SUMATOKCHARGE1  = SUMATOKCHARGE  / TEMPOKR  '     
         
''        CAPACITYACCU2 = TIME * SUMATOKCHARGE1       '   
        
''        If UP = 0 Or DOWN = 0 Then BACKLIGHT = 1    ' 
        
''    Wend
                                                                                             
''GoTo DISCHARGE

'----------------------------------------------------
BEEP:                                  
    PIEZO = 1 : DelayMS 100 : PIEZO = 0 : DelayMS 100
''Return
'''-------------------------- --------------------------
''OSTANOV:
''    PWMOUT1 = 0
''    PWMOUT2 = 0
''    REGIM = 1
''    Minute=0
''    Hour=0
''    Cls
''    Clear BatCap
''    Clear CELLBAT
''    Clear CHARGECURENT
''    Clear DISCHARCURENT
''    Clear CAPACITYACCU2
''    Clear CAPACITYACCU3
''    Clear SUMATOKCHARGE
''    Clear SUMATOKCHARGE1
''    Clear TEMPOKR
''Return
'''-------------------------- --------------------------
''CLEARDISCHARGE:

''    PWMOUT2 = 0
''    Minute=0
''    Hour=0
    
''Return

'''-------------------------- --------------------------          
''DISCHARGEEND:

''    Print At 1, 1, "DIS END" 
''    'CAPACITYACCU2 = ERead 0
''    Print At 1, 10, Dec2 Hour, ":", Dec2 Minute
''    GoSub READADC
''    Print At 2, 1,  Dec3 UBATTERY , "V "
''    Print At 2, 10, Dec3 CAPACITYACCU2 , "Ah"
    
''    'VAR1 = ADIn 0              '    0-       VAR1
''    'UBATTERY = VAR1 / 40       '   25.75
    
''    BACKLIGHT = 1
''    Sec = 0
''    FAN = 0
''    CHARGEDIS = 0
''    COMPLETE = 1
''    PWMOUT1 = 0
''    PWMOUT2 = 0
    
''    GoSub SETPWM
    
''    If OK = 0 Then 
''              DelayMS 200
''              Cls
''              GoSub BEEP  
''              GoSub OSTANOV               
''              GoTo MainMENU
''    EndIf 

''GoTo DISCHARGEEND

'''-------------------------- --------------------------
''CHARGEEND:

''    Print At 1, 1, "CHR END"
''    Print At 1, 10, Dec2 Hour, ":", Dec2 Minute
    
''    GoSub READADC 
    
''    Print At 2, 1, Dec3 UBATTERY , "V "
    
''    'If BATTYPE = 1 Then CAPACITYACCU3 = ERead 0 ': Print At 1, 10, Dec3 CAPACITYACCU3 , "Ah"
''    'If BATTYPE = 2 Or BATTYPE = 3 Or BATTYPE = 4 Then CAPACITYACCU2 = ERead 0 ': Print At 1, 10, Dec3 CAPACITYACCU2 , "Ah"
''    If BATTYPE = 1 Then Print At 2, 10, Dec3 CAPACITYACCU3 , "Ah"
''    If BATTYPE = 2 Or BATTYPE = 3 Or BATTYPE = 4 Then Print At 2, 10, Dec3 CAPACITYACCU2 , "Ah"
     
''    'VAR1 = ADIn 0              '    0-       VAR1
''    'UBATTERY = VAR1 / 40       '   25.75
                                                                 
    
''    BACKLIGHT = 1
''    Sec = 0
''    FAN = 0
''    CHARGEDIS = 0
''    COMPLETE = 1
''    PWMOUT1 = 0
''    PWMOUT2 = 0
    
''    GoSub SETPWM
    
''    If OK = 0 Then 
''              DelayMS 200
''              Cls
''              GoSub BEEP  
''              GoSub OSTANOV               
''              GoTo MainMENU
''    EndIf 

''GoTo CHARGEEND
'''-------------------------- --------------------------
''NOBATTERY:

''    Print At 1, 6, "ERRORS"
''    Print At 2, 4, "NO  BATTERY" 
    
''    Sec = 0
''    FAN = 0
''    CHARGEDIS = 1
''    COMPLETE = 1
''    PWMOUT1 = 0
''    PWMOUT2 = 0
    
''    GoSub SETPWM
    
''    If OK = 0 Then 
''              DelayMS 200
''              GoSub BEEP  
''              GoSub OSTANOV               
''              GoTo MainMENU
''    EndIf 

''GoTo NOBATTERY

'''-------------------------- --------------------------
''SHORTCIRCUT:

''    Print At 1, 6, "ERRORS"
''    Print At 2, 2, "SHORT  CIRCUIT"
    
''    Sec = 0
''    FAN = 0
''    CHARGEDIS = 1
''    COMPLETE = 1
''    PWMOUT1 = 0
''    PWMOUT2 = 0
    
''    GoSub SETPWM
    
''    If OK = 0 Then 
''              DelayMS 200
''              GoSub BEEP  
''              GoSub OSTANOV               
''              GoTo MainMENU
''    EndIf                                      

''GoTo SHORTCIRCUT
'-------------------------- --------------------------
SETPWM:                 '   

    HPWM 1, PWMOUT1 , 16000
    HPWM 2, PWMOUT2 , 16000

Return
'--------------------------ADC--------------------------
READADC:

    VAR1 = ADIn 0              '    0-       VAR1
    TempVAR1 = (TempVAR1 + VAR1 * 31) / 32
    UBATTERY = TempVAR1 / 40       '   25.75
    
    VAR2 = ADIn 1 	           '    1-       VAR2 
    TempVAR2  =  (TempVAR2 + VAR2 * 31) / 32
    TOKCHARGE = TempVAR2 / 200
    
    VAR3 = ADIn 2
    TempVAR3  =  (TempVAR3 + VAR3 * 31) / 32
    TOKDISCHARGE = TempVAR3 /  200 
           
Return

